git-rebase.shon commit clang-format: outline the git project's coding style (6134de6)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git-rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27f,force-rebase!    force rebase even if branch is up to date
  28X,strategy-option=! pass the argument through to the merge strategy
  29stat!              display a diffstat of what changed upstream
  30n,no-stat!         do not show diffstat of what changed upstream
  31verify             allow pre-rebase hook to run
  32rerere-autoupdate  allow rerere to update index with resolved conflicts
  33root!              rebase all reachable commits up to the root(s)
  34autosquash         move commits that begin with squash!/fixup! under -i
  35committer-date-is-author-date! passed to 'git am'
  36ignore-date!       passed to 'git am'
  37signoff            passed to 'git am'
  38whitespace=!       passed to 'git apply'
  39ignore-whitespace! passed to 'git apply'
  40C=!                passed to 'git apply'
  41S,gpg-sign?        GPG-sign commits
  42 Actions:
  43continue!          continue
  44abort!             abort and check out the original branch
  45skip!              skip current patch and continue
  46edit-todo!         edit the todo list during an interactive rebase
  47quit!              abort but keep HEAD where it is
  48"
  49. git-sh-setup
  50set_reflog_action rebase
  51require_work_tree_exists
  52cd_to_toplevel
  53
  54LF='
  55'
  56ok_to_skip_pre_rebase=
  57resolvemsg="
  58$(gettext 'Resolve all conflicts manually, mark them as resolved with
  59"git add/rm <conflicted_files>", then run "git rebase --continue".
  60You can instead skip this commit: run "git rebase --skip".
  61To abort and get back to the state before "git rebase", run "git rebase --abort".')
  62"
  63unset onto
  64unset restrict_revision
  65cmd=
  66strategy=
  67strategy_opts=
  68do_merge=
  69merge_dir="$GIT_DIR"/rebase-merge
  70apply_dir="$GIT_DIR"/rebase-apply
  71verbose=
  72diffstat=
  73test "$(git config --bool rebase.stat)" = true && diffstat=t
  74autostash="$(git config --bool rebase.autostash || echo false)"
  75fork_point=auto
  76git_am_opt=
  77rebase_root=
  78force_rebase=
  79allow_rerere_autoupdate=
  80# Non-empty if a rebase was in progress when 'git rebase' was invoked
  81in_progress=
  82# One of {am, merge, interactive}
  83type=
  84# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  85state_dir=
  86# One of {'', continue, skip, abort}, as parsed from command line
  87action=
  88preserve_merges=
  89autosquash=
  90keep_empty=
  91test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  92case "$(git config --bool commit.gpgsign)" in
  93true)   gpg_sign_opt=-S ;;
  94*)      gpg_sign_opt= ;;
  95esac
  96
  97read_basic_state () {
  98        test -f "$state_dir/head-name" &&
  99        test -f "$state_dir/onto" &&
 100        head_name=$(cat "$state_dir"/head-name) &&
 101        onto=$(cat "$state_dir"/onto) &&
 102        # We always write to orig-head, but interactive rebase used to write to
 103        # head. Fall back to reading from head to cover for the case that the
 104        # user upgraded git with an ongoing interactive rebase.
 105        if test -f "$state_dir"/orig-head
 106        then
 107                orig_head=$(cat "$state_dir"/orig-head)
 108        else
 109                orig_head=$(cat "$state_dir"/head)
 110        fi &&
 111        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 112        test -f "$state_dir"/verbose && verbose=t
 113        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 114        test -f "$state_dir"/strategy_opts &&
 115                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 116        test -f "$state_dir"/allow_rerere_autoupdate &&
 117                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 118        test -f "$state_dir"/gpg_sign_opt &&
 119                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 120}
 121
 122write_basic_state () {
 123        echo "$head_name" > "$state_dir"/head-name &&
 124        echo "$onto" > "$state_dir"/onto &&
 125        echo "$orig_head" > "$state_dir"/orig-head &&
 126        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 127        test t = "$verbose" && : > "$state_dir"/verbose
 128        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 129        test -n "$strategy_opts" && echo "$strategy_opts" > \
 130                "$state_dir"/strategy_opts
 131        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 132                "$state_dir"/allow_rerere_autoupdate
 133        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 134}
 135
 136output () {
 137        case "$verbose" in
 138        '')
 139                output=$("$@" 2>&1 )
 140                status=$?
 141                test $status != 0 && printf "%s\n" "$output"
 142                return $status
 143                ;;
 144        *)
 145                "$@"
 146                ;;
 147        esac
 148}
 149
 150move_to_original_branch () {
 151        case "$head_name" in
 152        refs/*)
 153                message="rebase finished: $head_name onto $onto"
 154                git update-ref -m "$message" \
 155                        $head_name $(git rev-parse HEAD) $orig_head &&
 156                git symbolic-ref \
 157                        -m "rebase finished: returning to $head_name" \
 158                        HEAD $head_name ||
 159                die "$(eval_gettext "Could not move back to \$head_name")"
 160                ;;
 161        esac
 162}
 163
 164apply_autostash () {
 165        if test -f "$state_dir/autostash"
 166        then
 167                stash_sha1=$(cat "$state_dir/autostash")
 168                if git stash apply $stash_sha1 2>&1 >/dev/null
 169                then
 170                        echo "$(gettext 'Applied autostash.')" >&2
 171                else
 172                        git stash store -m "autostash" -q $stash_sha1 ||
 173                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 174                        gettext 'Applying autostash resulted in conflicts.
 175Your changes are safe in the stash.
 176You can run "git stash pop" or "git stash drop" at any time.
 177' >&2
 178                fi
 179        fi
 180}
 181
 182finish_rebase () {
 183        apply_autostash &&
 184        { git gc --auto || true; } &&
 185        rm -rf "$state_dir"
 186}
 187
 188run_specific_rebase () {
 189        if [ "$interactive_rebase" = implied ]; then
 190                GIT_EDITOR=:
 191                export GIT_EDITOR
 192                autosquash=
 193        fi
 194        . git-rebase--$type
 195        ret=$?
 196        if test $ret -eq 0
 197        then
 198                finish_rebase
 199        elif test $ret -eq 2 # special exit status for rebase -i
 200        then
 201                apply_autostash &&
 202                rm -rf "$state_dir" &&
 203                die "Nothing to do"
 204        fi
 205        exit $ret
 206}
 207
 208run_pre_rebase_hook () {
 209        if test -z "$ok_to_skip_pre_rebase" &&
 210           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 211        then
 212                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 213                die "$(gettext "The pre-rebase hook refused to rebase.")"
 214        fi
 215}
 216
 217test -f "$apply_dir"/applying &&
 218        die "$(gettext "It looks like git-am is in progress. Cannot rebase.")"
 219
 220if test -d "$apply_dir"
 221then
 222        type=am
 223        state_dir="$apply_dir"
 224elif test -d "$merge_dir"
 225then
 226        if test -f "$merge_dir"/interactive
 227        then
 228                type=interactive
 229                interactive_rebase=explicit
 230        else
 231                type=merge
 232        fi
 233        state_dir="$merge_dir"
 234fi
 235test -n "$type" && in_progress=t
 236
 237total_argc=$#
 238while test $# != 0
 239do
 240        case "$1" in
 241        --no-verify)
 242                ok_to_skip_pre_rebase=yes
 243                ;;
 244        --verify)
 245                ok_to_skip_pre_rebase=
 246                ;;
 247        --continue|--skip|--abort|--quit|--edit-todo)
 248                test $total_argc -eq 2 || usage
 249                action=${1##--}
 250                ;;
 251        --onto=*)
 252                onto="${1#--onto=}"
 253                ;;
 254        --exec=*)
 255                cmd="${cmd}exec ${1#--exec=}${LF}"
 256                test -z "$interactive_rebase" && interactive_rebase=implied
 257                ;;
 258        --interactive)
 259                interactive_rebase=explicit
 260                ;;
 261        --keep-empty)
 262                keep_empty=yes
 263                ;;
 264        --preserve-merges)
 265                preserve_merges=t
 266                test -z "$interactive_rebase" && interactive_rebase=implied
 267                ;;
 268        --autosquash)
 269                autosquash=t
 270                ;;
 271        --no-autosquash)
 272                autosquash=
 273                ;;
 274        --fork-point)
 275                fork_point=t
 276                ;;
 277        --no-fork-point)
 278                fork_point=
 279                ;;
 280        --merge)
 281                do_merge=t
 282                ;;
 283        --strategy-option=*)
 284                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 285                do_merge=t
 286                test -z "$strategy" && strategy=recursive
 287                ;;
 288        --strategy=*)
 289                strategy="${1#--strategy=}"
 290                do_merge=t
 291                ;;
 292        --no-stat)
 293                diffstat=
 294                ;;
 295        --stat)
 296                diffstat=t
 297                ;;
 298        --autostash)
 299                autostash=true
 300                ;;
 301        --no-autostash)
 302                autostash=false
 303                ;;
 304        --verbose)
 305                verbose=t
 306                diffstat=t
 307                GIT_QUIET=
 308                ;;
 309        --quiet)
 310                GIT_QUIET=t
 311                git_am_opt="$git_am_opt -q"
 312                verbose=
 313                diffstat=
 314                ;;
 315        --whitespace=*)
 316                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 317                case "${1#--whitespace=}" in
 318                fix|strip)
 319                        force_rebase=t
 320                        ;;
 321                esac
 322                ;;
 323        --ignore-whitespace)
 324                git_am_opt="$git_am_opt $1"
 325                ;;
 326        --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
 327                git_am_opt="$git_am_opt $1"
 328                force_rebase=t
 329                ;;
 330        -C*)
 331                git_am_opt="$git_am_opt $1"
 332                ;;
 333        --root)
 334                rebase_root=t
 335                ;;
 336        --force-rebase|--no-ff)
 337                force_rebase=t
 338                ;;
 339        --rerere-autoupdate|--no-rerere-autoupdate)
 340                allow_rerere_autoupdate="$1"
 341                ;;
 342        --gpg-sign)
 343                gpg_sign_opt=-S
 344                ;;
 345        --gpg-sign=*)
 346                gpg_sign_opt="-S${1#--gpg-sign=}"
 347                ;;
 348        --)
 349                shift
 350                break
 351                ;;
 352        esac
 353        shift
 354done
 355test $# -gt 2 && usage
 356
 357if test -n "$action"
 358then
 359        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 360        # Only interactive rebase uses detailed reflog messages
 361        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 362        then
 363                GIT_REFLOG_ACTION="rebase -i ($action)"
 364                export GIT_REFLOG_ACTION
 365        fi
 366fi
 367
 368if test "$action" = "edit-todo" && test "$type" != "interactive"
 369then
 370        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 371fi
 372
 373case "$action" in
 374continue)
 375        # Sanity check
 376        git rev-parse --verify HEAD >/dev/null ||
 377                die "$(gettext "Cannot read HEAD")"
 378        git update-index --ignore-submodules --refresh &&
 379        git diff-files --quiet --ignore-submodules || {
 380                echo "$(gettext "You must edit all merge conflicts and then
 381mark them as resolved using git add")"
 382                exit 1
 383        }
 384        read_basic_state
 385        run_specific_rebase
 386        ;;
 387skip)
 388        output git reset --hard HEAD || exit $?
 389        read_basic_state
 390        run_specific_rebase
 391        ;;
 392abort)
 393        git rerere clear
 394        read_basic_state
 395        case "$head_name" in
 396        refs/*)
 397                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 398                die "$(eval_gettext "Could not move back to \$head_name")"
 399                ;;
 400        esac
 401        output git reset --hard $orig_head
 402        finish_rebase
 403        exit
 404        ;;
 405quit)
 406        exec rm -rf "$state_dir"
 407        ;;
 408edit-todo)
 409        run_specific_rebase
 410        ;;
 411esac
 412
 413# Make sure no rebase is in progress
 414if test -n "$in_progress"
 415then
 416        state_dir_base=${state_dir##*/}
 417        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 418        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 419        die "
 420$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 421I wonder if you are in the middle of another rebase.  If that is the
 422case, please try
 423        $cmd_live_rebase
 424If that is not the case, please
 425        $cmd_clear_stale_rebase
 426and run me again.  I am stopping in case you still have something
 427valuable there.')"
 428fi
 429
 430if test -n "$rebase_root" && test -z "$onto"
 431then
 432        test -z "$interactive_rebase" && interactive_rebase=implied
 433fi
 434
 435if test -n "$interactive_rebase"
 436then
 437        type=interactive
 438        state_dir="$merge_dir"
 439elif test -n "$do_merge"
 440then
 441        type=merge
 442        state_dir="$merge_dir"
 443else
 444        type=am
 445        state_dir="$apply_dir"
 446fi
 447
 448if test -z "$rebase_root"
 449then
 450        case "$#" in
 451        0)
 452                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 453                        --verify -q @{upstream} 2>/dev/null)
 454                then
 455                        . git-parse-remote
 456                        error_on_missing_default_upstream "rebase" "rebase" \
 457                                "against" "git rebase $(gettext '<branch>')"
 458                fi
 459
 460                test "$fork_point" = auto && fork_point=t
 461                ;;
 462        *)      upstream_name="$1"
 463                if test "$upstream_name" = "-"
 464                then
 465                        upstream_name="@{-1}"
 466                fi
 467                shift
 468                ;;
 469        esac
 470        upstream=$(peel_committish "${upstream_name}") ||
 471        die "$(eval_gettext "invalid upstream \$upstream_name")"
 472        upstream_arg="$upstream_name"
 473else
 474        if test -z "$onto"
 475        then
 476                empty_tree=$(git hash-object -t tree /dev/null)
 477                onto=$(git commit-tree $empty_tree </dev/null)
 478                squash_onto="$onto"
 479        fi
 480        unset upstream_name
 481        unset upstream
 482        test $# -gt 1 && usage
 483        upstream_arg=--root
 484fi
 485
 486# Make sure the branch to rebase onto is valid.
 487onto_name=${onto-"$upstream_name"}
 488case "$onto_name" in
 489*...*)
 490        if      left=${onto_name%...*} right=${onto_name#*...} &&
 491                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 492        then
 493                case "$onto" in
 494                ?*"$LF"?*)
 495                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 496                        ;;
 497                '')
 498                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 499                        ;;
 500                esac
 501        else
 502                die "$(eval_gettext "\$onto_name: there is no merge base")"
 503        fi
 504        ;;
 505*)
 506        onto=$(peel_committish "$onto_name") ||
 507        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 508        ;;
 509esac
 510
 511# If the branch to rebase is given, that is the branch we will rebase
 512# $branch_name -- branch being rebased, or HEAD (already detached)
 513# $orig_head -- commit object name of tip of the branch before rebasing
 514# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 515switch_to=
 516case "$#" in
 5171)
 518        # Is it "rebase other $branchname" or "rebase other $commit"?
 519        branch_name="$1"
 520        switch_to="$1"
 521
 522        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 523           orig_head=$(git rev-parse -q --verify "refs/heads/$1")
 524        then
 525                head_name="refs/heads/$1"
 526        elif orig_head=$(git rev-parse -q --verify "$1")
 527        then
 528                head_name="detached HEAD"
 529        else
 530                die "$(eval_gettext "fatal: no such branch: \$branch_name")"
 531        fi
 532        ;;
 5330)
 534        # Do not need to switch branches, we are already on it.
 535        if branch_name=$(git symbolic-ref -q HEAD)
 536        then
 537                head_name=$branch_name
 538                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 539        else
 540                head_name="detached HEAD"
 541                branch_name=HEAD ;# detached
 542        fi
 543        orig_head=$(git rev-parse --verify HEAD) || exit
 544        ;;
 545*)
 546        die "BUG: unexpected number of arguments left to parse"
 547        ;;
 548esac
 549
 550if test "$fork_point" = t
 551then
 552        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 553                        "${switch_to:-HEAD}")
 554        if test -n "$new_upstream"
 555        then
 556                restrict_revision=$new_upstream
 557        fi
 558fi
 559
 560if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 561then
 562        stash_sha1=$(git stash create "autostash") ||
 563        die "$(gettext 'Cannot autostash')"
 564
 565        mkdir -p "$state_dir" &&
 566        echo $stash_sha1 >"$state_dir/autostash" &&
 567        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 568        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 569        git reset --hard
 570fi
 571
 572require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 573
 574# Now we are rebasing commits $upstream..$orig_head (or with --root,
 575# everything leading up to $orig_head) on top of $onto
 576
 577# Check if we are already based on $onto with linear history,
 578# but this should be done only when upstream and onto are the same
 579# and if this is not an interactive rebase.
 580mb=$(git merge-base "$onto" "$orig_head")
 581if test "$type" != interactive && test "$upstream" = "$onto" &&
 582        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 583        # linear history?
 584        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 585then
 586        if test -z "$force_rebase"
 587        then
 588                # Lazily switch to the target branch if needed...
 589                test -z "$switch_to" ||
 590                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 591                        git checkout -q "$switch_to" --
 592                say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 593                finish_rebase
 594                exit 0
 595        else
 596                say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 597        fi
 598fi
 599
 600# If a hook exists, give it a chance to interrupt
 601run_pre_rebase_hook "$upstream_arg" "$@"
 602
 603if test -n "$diffstat"
 604then
 605        if test -n "$verbose"
 606        then
 607                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 608        fi
 609        # We want color (if set), but no pager
 610        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 611fi
 612
 613test "$type" = interactive && run_specific_rebase
 614
 615# Detach HEAD and reset the tree
 616say "$(gettext "First, rewinding head to replay your work on top of it...")"
 617
 618GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 619        git checkout -q "$onto^0" || die "could not detach HEAD"
 620git update-ref ORIG_HEAD $orig_head
 621
 622# If the $onto is a proper descendant of the tip of the branch, then
 623# we just fast-forwarded.
 624if test "$mb" = "$orig_head"
 625then
 626        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 627        move_to_original_branch
 628        finish_rebase
 629        exit 0
 630fi
 631
 632if test -n "$rebase_root"
 633then
 634        revisions="$onto..$orig_head"
 635else
 636        revisions="${restrict_revision-$upstream}..$orig_head"
 637fi
 638
 639run_specific_rebase